import 'package:freezed_annotation/freezed_annotation.dart';

part 'base_object_response.g.dart';

@JsonSerializable(genericArgumentFactories: true)
class BaseObjectResponse<T> {
  final T? data;
  final Object? success;
  final Object? message;

  BaseObjectResponse(
      {@JsonKey(name: 'data') required this.data,
      @JsonKey(name: 'success') this.success,
      @JsonKey(name: 'message') this.message});

  factory BaseObjectResponse.fromJson(
          Map<String, dynamic> json, T Function(dynamic) fromJsonT) =>
      _$BaseObjectResponseFromJson(json, fromJsonT);
}
