import 'package:flutter/material.dart';
import 'package:sharing/common/values/hex_color.dart';
import 'package:sharing/remote/local/shared_prefers_helper.dart';
import 'package:sharing/remote/model/application_config.dart';

class CustomBackgroundGradient extends StatefulWidget {
  CustomBackgroundGradient(
      {Key? key,
      required this.child,
      this.isScoll = false,
      this.imageCustom,
      this.applicationConfig})
      : super(key: key);
  final ApplicationConfig? applicationConfig;
  final Widget child;
  final bool? isScoll;
  final Widget? imageCustom;

  @override
  State<CustomBackgroundGradient> createState() =>
      _CustomBackgroundGradientState();
}

class _CustomBackgroundGradientState extends State<CustomBackgroundGradient> {
  @override
  Widget build(BuildContext context) {
    return Container(
      decoration: BoxDecoration(
        gradient: LinearGradient(
          begin: Alignment(widget.applicationConfig?.begin?[0] ?? 0.0,
              widget.applicationConfig?.begin?[1] ?? -1.0),
          end: Alignment(widget.applicationConfig?.end?[0] ?? 0.0,
              widget.applicationConfig?.end?[1] ?? 1.0),
          colors: [
            if (widget.applicationConfig?.primaryColor?.isNotEmpty == true) ...[
              HexColor(widget.applicationConfig?.primaryColor ?? ""),
            ] else ...[
              Theme.of(context).primaryColor
            ],
            if (widget.applicationConfig?.primarySecondColor?.isNotEmpty ==
                true) ...[
              HexColor(widget.applicationConfig?.primarySecondColor ?? ""),
            ] else ...[
              Theme.of(context).primaryColorLight
            ]
          ],
        ),
      ),
      child: widget.isScoll == true
          ? Stack(
              children: [
                widget.imageCustom ?? Container(),
                FlexibleSpaceBar(
                    centerTitle: true,
                    titlePadding: EdgeInsets.all(20),
                    background: widget.child),
              ],
            )
          : Stack(
              children: [
                widget.imageCustom ?? Container(),
                widget.child,
              ],
            ),
    );
  }
}
